/*
 *  GOL - Game of life simulation software
 *  Copyright (C) 1996 Michael Raymond Brown
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 *  Author: Michael Raymond Brown
 *  EMail:  michael@arrakeen.demon.co.uk
 *  WWW:    http://www.arrakeen.demon.co.uk/
 *  Address:  Michael Brown
 *            Kia Ora
 *            Brook Street
 *            Great Bromley
 *            Nr Colchester
 *            Essex
 *            CO7 7HX
 *            England
 */


#ifdef __GNUC__
#pragma implementation
#endif

#include "ScrollArea.h"


xwScrollArea::xwScrollArea(xwWidget* p, int x1, int y1, int x2, int y2)
   {
    parent = p;
    widget = XtVaCreateManagedWidget("window"
		, xmScrolledWindowWidgetClass, parent->getWidget()
		, XmNscrollingPolicy, XmAUTOMATIC
		, XmNscrollBarDisplayPolicy, XmSTATIC

		, XmNleftAttachment,	XmATTACH_POSITION
		, XmNrightAttachment,	XmATTACH_POSITION
		, XmNtopAttachment,	XmATTACH_POSITION
		, XmNbottomAttachment,	XmATTACH_POSITION

		, XmNleftPosition,	x1
		, XmNrightPosition,	x2
		, XmNtopPosition,	y1
		, XmNbottomPosition,	y2

		, 0);

    default_callbacks(0, meth_Size|meth_Close);
    linkParent(p);
   }
xwScrollArea::xwScrollArea(xwWidget* p)
   {
    parent = p;
    widget = XtVaCreateManagedWidget("window"
		, xmScrolledWindowWidgetClass, parent->getWidget()
		, XmNscrollingPolicy, XmAUTOMATIC
		, XmNscrollBarDisplayPolicy, XmSTATIC
		, 0);

    default_callbacks(0, meth_Size|meth_Close);
    linkParent(p);
   }
xwScrollArea::~xwScrollArea()
   {
   }


void xwScrollArea::getView(int* x, int* y, int* width, int* height)
   {Widget    clip;
    Widget scrollx;
    Widget scrolly;
    Widget workwin;
    Dimension w, h;
    Dimension ww, wh;
    XtVaGetValues(widget
		, XmNclipWindow, &clip
		, XmNhorizontalScrollBar, &scrollx
		, XmNverticalScrollBar, &scrolly
		, XmNworkWindow, &workwin
		, 0);
    XtVaGetValues(scrollx, XmNvalue, x, 0);
    XtVaGetValues(scrolly, XmNvalue, y, 0);
    XtVaGetValues(clip, XmNwidth, &w, XmNheight, &h, 0);
    XtVaGetValues(workwin, XmNwidth, &ww, XmNheight, &wh, 0);
    if ((*x==0) && (w>ww)) w=ww;
    if ((*y==0) && (h>wh)) h=wh;
    *width=w; *height=h;
   }

